real sigma=8.;

func g=x^5/5.-x^4/2.+x^3/3.;
func dg=x^4-2.*x^3+x^2;
func d2g=4.*x^3-6.*x^2+2.*x;
func d3g=12.*x^2-12.*x+2.;
func d4g=24.*x-12.;

func h=y^4-y^2;
func dh=4.*y^3-2.*y;
func d2h=12.*y^2-2.;
func d3h=24.*y;
func d4h=24.;

func beta1=cos(pi*x);
func dbeta1=-pi*sin(pi*x);
func d2beta1=-pi^2*cos(pi*x);

func beta2=y-y^2;
func dbeta2=1.-2.*y;
func d2beta2=-2.;

func u1ex=sigma*dg*dh;
func dxu1ex=sigma*d2g*dh;
func dyu1ex=sigma*dg*d2h;

func u2ex=-sigma*d2g*h;
func dxu2ex=-sigma*d3g*h;
func dyu2ex=-sigma*d2g*dh;

func pex=sigma*IRe*(d3h*g+d2g*dh) + sigma^2/2*dg^2*(h*d2h-dh^2);

func Tlin=Tcold+(Thot-Tcold)*y;
func dxTlin=0.;
func dyTlin=Thot-Tcold;
func Tex=Tlin + beta1*beta2;
func dxTex=dxTlin + dbeta1*beta2;
func dyTex=dyTlin + beta1*dbeta2;

func fu1=0.;
func fu2=sigma^2*h*dh*(d2g^2-dg*d3g)+sigma*IRe*(d4g*h+2*d2g*d2h+d4h*g)
       +sigma^2/2*dg^2*(h*d3h-dh*d2h)-IRa*Tex;
func fT=u1ex*(dxTlin + dbeta1*beta2) + u2ex*(dyTlin + beta1*dbeta2) - IPr*(d2beta1*beta2+beta1*d2beta2);

func ubnd = 2.*sigma*dg;